add modules and module operations

29 Jun 2012 18:53 - Anna Maria Bigatti

Status: Closed Start date: 29 Jun 2012

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: CoCoA-4 function to be added Estimated time: 27.00 hours

Target version: CoCoA-5.1.0 Easter14 Spent time: 27.05 hours

Description

We have modules in CoCoALib.

Just mimick ideals to add modules..... will it be that easy?

Probably we'll have some surprises with module operations... cross fingers!!

Related issues:

Related to CoCoALib - Design #297: Modules design: brainstorming In Progress 25 Jan 2013

Related to CoCoALib - Feature #304: Module ordering and grading (and shifts) Closed 11 Feb 2013

Related to CoCoALib - Design #305: FreeModule: unique copy? In Progress 12 Feb 2013

Related to CoCoA-5 - Feature #330: Syzygy for modules: homogeneous module Closed 15 Mar 2013

Related to CoCoA-5 - Feature #388: port optimized resolutions to CoCoA-5 New 23 Jul 2013

Related to CoCoALib - Feature #387: implement algorithm(s) for resolutions New 23 Jul 2013

Related to CoCoA-5 - Support #341: Remove/replace the word "vector" in the ma... Closed 17 Apr 2013

Related to CoCoA-5 - Bug #509: SyzOfGens (CoCoA-5) does not have correct shifts Closed 03 Apr 2014

Related to CoCoA-5 - Feature #702: Add more operations for modules New 15 May 2015

Related to CoCoALib - Design #703: Add more operations between modules (CoCoA... New 15 May 2015

History

#1 - 22 Jan 2013 17:17 - Anna Maria Bigatti

- Status changed from New to In Progress

- % Done changed from 0 to 10

added types MODULE and MODULEELEM.

added functions: NewFreeModule, arithmetics for type MODULEELEM.

#2 - 22 Jan 2013 18:17 - Anna Maria Bigatti

- Category set to CoCoA-4 function to be added

- Assignee set to Anna Maria Bigatti

- Target version set to CoCoA-5.0.3

added zero(module), BaseRing(module), RingOf(module), RingOf(ModuleElem)

added stub documentation

#3 - 23 Jan 2013 15:52 - Anna Maria Bigatti

- % Done changed from 10 to 20

#4 - 12 Feb 2013 11:03 - Anna Maria Bigatti

added LPP, LPosn, LT, wdeg

#5 - 13 Feb 2013 10:13 - Anna Maria Bigatti
added FirstNonZeroPosn, homog(ModuleElem) (for GradingDim=1)

#6 - 20 Feb 2013 18:04 - Anna Maria Bigatti

Added SyzOfGens for an ideal both in cocoalib and cocoa-5

(and manual in cocoa-5).

This is still quite rough as there is no control on the module in which the output resides (this is automatically created in the raw C++ code).

There should be at least the possibility of passing the free module so that two successful computation reside in the same module.

/**/  I := Ideal(x, x, y);

/**/  SyzOfGens(I);

submodule(FreeModule(...), [[1, -1, 0], [0, y, -x]])

#7 - 21 Feb 2013 17:20 - Anna Maria Bigatti

added GensAsRows, GensAsCols  (and manual)

added NewFreeModuleForSyz + consequences

#8 - 21 Feb 2013 18:13 - Anna Maria Bigatti

- Estimated time changed from 10.00 h to 20.00 h

#9 - 22 Feb 2013 13:42 - Anna Maria Bigatti

added GenRepr in packages/hilop

#10 - 08 Apr 2013 15:52 - John Abbott

New module fns to add:

rank

IsIn

equality test

#11 - 31 May 2013 18:04 - Anna Maria Bigatti

- % Done changed from 20 to 30

#12 - 04 Jun 2013 07:24 - Anna Maria Bigatti

John Abbott wrote:

IsIn

equality test

 

added IsElem, IsContained for (sub)modules, and then IsIn and equality test
#13 - 31 Jul 2013 15:53 - Anna Maria Bigatti

- Target version changed from CoCoA-5.0.3 to CoCoA-5.0.9

- % Done changed from 30 to 50

added v[i] where v is a ModuleElem (real miracle in Interpreter.[HC], indexedByBigInt),

added IsHomog(M), IsZero(M), LT for M (sub)module.

currently working on HilbertSeries.

#14 - 31 Jul 2013 16:39 - Anna Maria Bigatti

added NumCompts for MODULE annd MODULEELEM

#15 - 01 Aug 2013 15:49 - Anna Maria Bigatti

added LC and DivAlg, fixed manual entries.

renamed LPos into LPosn.

#16 - 25 Mar 2014 17:37 - John Abbott

- Target version changed from CoCoA-5.0.9 to CoCoA-5.1.0 Easter14

#17 - 28 Mar 2014 09:08 - Anna Maria Bigatti

Added MinGens

#18 - 08 Apr 2014 17:54 - Anna Maria Bigatti

- % Done changed from 50 to 60

added submodule(gens)

where gens is a non-empty vector of ModuleElem in the same Module.

#19 - 08 Apr 2014 20:14 - Anna Maria Bigatti

added shifts(FreeModule)

#20 - 11 Apr 2014 15:03 - Anna Maria Bigatti

- Status changed from In Progress to Closed

- % Done changed from 60 to 100

Most operations have been implemented by now.

Remaining functions will be under their own "issue".

#21 - 15 May 2015 09:02 - Anna Maria Bigatti

- Estimated time changed from 20.00 h to 27.00 h
